{-# LANGUAGE RankNTypes, FlexibleContexts #-}

{-
  This module is part of Antisplice.
  Copyleft (c) 2014 Marvin Cohrs

  All wrongs reversed. Sharing is an act of love, not crime.
  Please share Antisplice with everyone you like.

  Antisplice is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Antisplice is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with Antisplice. If not, see <http://www.gnu.org/licenses/>.
-}

-- | Reexports all relevant modules

module Game.Antisplice (
  -- * Reexported modules
  module Game.Antisplice.Monad,
  module Game.Antisplice.Monad.Dungeon,
  module Game.Antisplice.Monad.Vocab,
  module Game.Antisplice.Utils.Fail,
  module Game.Antisplice.Utils.Atoms,
  module Game.Antisplice.Utils.None,
  module Game.Antisplice.Utils.BST,
  module Game.Antisplice.Utils.Counter,
  module Game.Antisplice.Rooms,
  module Game.Antisplice.Stats,
  module Game.Antisplice.Prototypes,
  module Game.Antisplice.Lang,
  module Game.Antisplice.Errors,
  module Game.Antisplice.Terminal.Repl,
  module Game.Antisplice.Events,
  -- * Type abbreviations
  Constructor) where

import Text.Chatty.Printer
import Text.Chatty.Scanner
import Text.Chatty.Expansion
import Text.Chatty.Extended.Printer
import System.Chatty.Misc
import Game.Antisplice.Monad
import Game.Antisplice.Monad.Dungeon
import Game.Antisplice.Monad.Vocab
import Game.Antisplice.Utils.Fail
import Game.Antisplice.Utils.Atoms
import Game.Antisplice.Utils.None
import Game.Antisplice.Utils.BST
import Game.Antisplice.Utils.Counter
import Game.Antisplice.Rooms
import Game.Antisplice.Stats
import Game.Antisplice.Prototypes
import Game.Antisplice.Lang
import Game.Antisplice.Errors
import Game.Antisplice.Terminal.Repl
import Game.Antisplice.Events
import Control.Monad.Error.Class

-- | A dungeon constructor function
type Constructor = forall m.(Functor m,ExtendedPrinter m,MonadExpand m,ExpanderEnv m,MonadScanner m,MonadAtoms m,MonadClock m,MonadVocab m,MonadError SplErr m) => DungeonT m ()
