{-
  This module is part of Antisplice.
  Copyleft (c) 2014 Marvin Cohrs

  All wrongs reversed. Sharing is an act of love, not crime.
  Please share Antisplice with everyone you like.

  Antisplice is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Antisplice is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with Antisplice. If not, see <http://www.gnu.org/licenses/>.
-}

-- | Provides the error datatype for Antisplice
module Game.Antisplice.Errors where

import Game.Antisplice.Utils.Fail

-- | Antisplice errors
data SplErr = UnknownError
            | QuitError
            | DoneError  
            | UnintellegibleError
            | VerbMustFirstError
            | CantSeeOneError
            | DontCarryOneError
            | WhichOneError
            | CantEquipThatError
            | CantEquipThatThereError
            | WhereToEquipError
            | CantWalkThereError deriving Show

-- | Alias for 'FailT' 'SplErr'
type SplErrT m = FailT SplErr m
